local_library/catalog/urls.py
from django.urls import path
from . import views
#from django.conf.urls import url

urlpatterns = [
    path('', views.index, name='index'),                # в locallibraruy/urls.py  - указано, что от /catalog/ 
    path('books', views.books_view, name='bOOks'),
    path('authors', views.autors_view, name='authOrs'), # пройдя то этой ссылке, вызывается метод autors_view из файла view.py
    path('book/view/<pk>', views.book_view, name='bOOk'),
    path('mybooks', views.mybook_view, name='mybOOks'),
    path('author/view/<pk>', views.autor_view, name='authOr'),
    path('author/create', views.autor_new, name='authCrd'),  
#    path('book/create', views.BookCreate.as_view(), name='bOOkCrd')
]
# urlpatterns += [   
#   url(r'^mybooks/$', views.LoanedBooksByUserListView.as_view(), name='my-bOrrOwed'), # Маршрут для class LoanedBooksByUserListView 
#]

local_library/catalog/models.py
from django.db import models
from django.urls import reverse #Used to generate URLs by reversing the URL patterns
import uuid # Требуется для уникальных экземпляров книг - Required for unique BookInstances
from django.contrib.auth.models import User #Импорт модели User из django.contrib.auth.models
"""добавим свойство, которое можно вызвать из шаблонов, чтобы указать, просрочен ли конкретный экземпляр книги. 
Хотя можно и рассчитать это в самом шаблоне, использование свойства, - здесь будет намного более эффективным."""
from datetime import date


'''Модели Базы Данных'''
class Genre(models.Model):
    """
    Модель жанра книги (e.g. Science Fiction, Non Fiction).
    """
    name = models.CharField(max_length=200, help_text="Характеристика произведения", verbose_name='Жанр') #help_text - это заголовок каждого поля админ интерфейса
    

    def __str__(self):
        """
        String for representing the Model object (in Admin site etc.)
        Строка для представления объекта модели.
        """
        return self.name

class Book(models.Model):
    """
    Модель книги (but not a specific copy of a book).
    """
    title = models.CharField(max_length=200, verbose_name='НАЗВАНИЕ')
    author = models.ForeignKey('Author', on_delete=models.SET_NULL, null=True, verbose_name='Автор')
    # Foreign Key used because book can only have one author, but authors can have multiple books
    # Author as a string rather than object because it hasn't been declared yet in the file.
    summary = models.TextField(max_length=1000, help_text="Пару предложений о произведении", verbose_name='О чём оно?')
    isbn = models.CharField('ISBN', max_length=13,
                            help_text='13 Символов <a href="https://www.isbn-international.org/content/what-isbn">ISBN number</a>')
    genre = models.ManyToManyField(Genre, help_text="Выберите жанровую характеристику произведения", verbose_name='ЖАНР ПРОИЗВЕДЕНИЯ')

    # ManyToManyField used because genre can contain many books. Books can cover many genres.
    # Genre class has already been defined so we can specify the object above.

    def __str__(self):
        """
        String for representing the Model object.
        Строка для представления объекта модели.
        """
        return self.title

    def get_absolute_url(self):
        """
        Returns the url to access a particular book instance.
        Возвращает url-адрес для доступа к конкретному экземпляру книги.
        """
        return reverse('bOOk', args=[str(self.id)])

    def display_genre(self):
        """
        Creates a string for the Genre. This is required to display genre in Admin.
        Создает строку для жанра. Это необходимо для отображения жанра в Admin.
        """
        return ', '.join([ genre.name for genre in self.genre.all()[:3] ])
    display_genre.short_description = 'Жанрррр'

class BookInstance(models.Model):
    """
    Модель копии книги (i.e. that can be borrowed from the library).
    """
    id = models.UUIDField(primary_key=True, default=uuid.uuid4,
                          help_text="Unique ID данной книги в этой библиотеке")  #help_text - это заголовок каждого поля админ интерфейса
    book = models.ForeignKey('Book', on_delete=models.SET_NULL, null=True, verbose_name='Произведение') #
    imprint = models.CharField(max_length=200)
    due_back = models.DateField(null=True, blank=True, verbose_name='До какого срока')
    # Заёмщик, должник
    borrower = models.ForeignKey(User, on_delete=models.SET_NULL, null=True, blank=True, verbose_name='У кого?') 
    """определение свойства внутри класса BookInstance"""
    @property
    def is_overdue(self):
        if self.due_back and date.today() > self.due_back:  # Сначала мы проверим, является ли due_back пустым, прежде 
            # чем проводить сравнение. Пустое поле due_back заставило Django выкидывать ошибку, а не показывать страницу: пустые 
            # значения не сопоставимы. Это не то, что мы хотели бы, чтобы наши пользователи испытывали!
            return True
        return False


    LOAN_STATUS = (
        ('р', 'на Реставрации'),
        ('в', 'Выдан'),
        ('д', 'Доступен'),
        ('з', 'Зарезервирован'),
    )

    status = models.CharField(max_length=1, choices=LOAN_STATUS, blank=True, default='m', help_text='Book availability') 
    #help_text - это заголовок каждого поля админ интерфейса

    class Meta:
        ordering = ["due_back"]

    def __str__(self):
        """
        String for representing the Model object
        """
        return '%s (%s)' % (self.id, self.book.title)

class Author(models.Model):
    """
    Модель Автора
    """
    first_name = models.CharField(max_length=21, help_text="Имя", verbose_name='ИМЯ')
    last_name = models.CharField(max_length=10, help_text="Фамилия", verbose_name="ФАМИЛИЯ")
    foto = models.ImageField(verbose_name='Портрет', upload_to = 'fts-athrs', null = True)
    date_of_birth = models.DateField(null=True, blank=True, verbose_name='Жил с...')
    date_of_death = models.DateField( null=True, blank=True, verbose_name='...жил до')

    def get_absolute_url(self):
        """
        Возвращает url-адрес для доступа к конкретному экземпляру author.
        """
        return reverse('authOr', args=[str(self.id)])

    def __str__(self):
        """
        Строка для представления объекта модели.
        """
        return '%s, %s' % (self.last_name, self.first_name)

local_library/catalog/forms.py
from django import forms
from django.db import models
from .models import Author
from django.forms import ModelForm, TextInput, DateInput, FileInput

class AuthorForm(ModelForm): # Новый класс мы наследуем от ModelForm
    class Meta:     # где указываем характеристики, для класса
        model = Author  # Модель, с которой мы работаем
        fields = ['last_name', 'first_name', 'date_of_birth', 'date_of_death', 'foto'] # Поля, которые должны быть выведены в форме
        widgets = {
            "last_name": TextInput(attrs={  # Словарь attrs содержит HTML атрибуты, которые будут назначены сгенерированному виджету.
                'class': 'form-control',
                'placeholder': "Фамилия"
            }),
            "first_name": TextInput(attrs={
                'class': 'form-control',
                'placeholder': "Имя и Отчество"
            }),
             "date_of_birth": DateInput(attrs={
                'class': 'form-control',
                'placeholder': "Родился"
            }),
            "date_of_death": DateInput(attrs={
                'class': 'form-control',
                'placeholder': "Умер"
            }),
             "foto": FileInput(attrs={
                'class': '',
                'placeholder': "Портрет"
            }),
            }
    

local_library/catalog/views.py
from django.shortcuts import render, redirect
from django.core.paginator import Paginator
#from .models import Book, Author, BookInstance, Genre # Создаются отображение Моделей
#-*-заменяет перечисление Моделей, говоря "все"
from .models import * 
from django.views import generic    # обобщенный класс уже реализует большую часть; ОбщиеПредставления GenericView - абстрагируют общие 
# шаблоны до такой степени, что вам даже не нужно писать код Python для написания приложения.

#from django.http import Http404,HttpResponseRedirect,  # class HttpResponseRedirect - перенаправляет на другой адрес (HTTP код статуса 302). 




def index(request):
    """
    Функция отображения для домашней страницы сайта.
    """

    # Генерация "количеств" некоторых главных объектов
    num_books = Book.objects.all().count()
    num_instances = BookInstance.objects.all().count()

    # Доступные книги (статус = 'a')
    num_instances_available = BookInstance.objects.filter(status__exact='a').count()
    num_authors = Author.objects.count()    # Метод 'all()' применен по умолчанию.

                    # Количество посещений этого представления, подсчитанное в переменной сессии. 
                    # HttpRequest передается как первый аргумент в каждое отображение.
    num_visits=request.session.get('nm_vsts', 0)     #Получаем значение 'num_visits' из сессии, возвращая 0, если оно не было установлено ранее
    request.session['nm_vsts'] = num_visits+1        #Каждый раз при получении запроса, мы увеличиваем данное значение на единицу и сохраняем его обратно в сессии (до следующего посещения данной страницы пользователем)
    num_visits_finish = ''
    remain_visits = num_visits
    if remain_visits < 12 or remain_visits > 19:
        remain_visits = num_visits % 10
        print("remain_visits = ", remain_visits)
    if remain_visits >= 2 or remain_visits <= 4:
        num_visits_finish = 'разa'
        print("raza remain_visits = ", remain_visits)
    else: num_visits_finish = 'раз'
     # Отрисовка HTML-шаблона index.html с данными внутри переменной контекста context=
    return render(
        request,
        'index.html',
        context={'nm_bks': num_books, 
                'num_instances': num_instances, 'num_instances_available': num_instances_available, 
                'nm_athrs': num_authors,
               'nm_vsts': num_visits, 'nm_vsts_fnsh': num_visits_finish }, # количество посещений. Переменная nm_vsts передается в шаблон через переменную контекста context=
            )


def books_view(request):
    """
    Функция отображения для страницы сайта Книги.
    """
    book_list = Book.objects.all() #запрашиваем из БД все объекты Book, и сохраняем в переменную book_list
    page = request.GET.get('page',1)
    paginator = Paginator(book_list,5)
    page_books_list = paginator.get_page(page)
    # Отрисовка HTML-шаблона index.html с данными внутри переменной контекста context=
    return render(
            request,
            'ctlg/book_list.html', #указывается html страница откуда будут приходить запросы request
            context={'p_bk_lst': page_books_list} #создаются имена к спискам для передачи в html при запросе request с указанной html страницы
        )

def book_view(request,pk):
    """
    Функция отображения для страницы сайта Книга.
    """
    # Запрашиваем запись с соответствующим <pk> в БД Book
    book = Book.objects.get(pk=pk) 
    # Отрисовка HTML-шаблона index.html с данными внутри переменной контекста context=
    return render(
        request,
        'ctlg/book_detail.html',
        context={'bk_dtl': book},
    )

 
def autors_view(request):
    """
    Функция отображения для страницы сайта Авторы.
    """
    
    autors_list = Author.objects.all() # Вызов всех записей из модели БД Авторы
    page = request.GET.get('page',1)
    paginator = Paginator(autors_list,3)
    page_autors_list = paginator.get_page(page)
    # Отрисовка HTML-шаблона index.html с данными внутри переменной контекста context=
    return render(
            request,
            'ctlg/autors_list.html',
            context={'p_athrs_lst': page_autors_list}
        )



def autor_view(request,pk):
    """
    Функция отображения для страницы сайта Автор.
    """
    
    autor_detail = Author.objects.get(pk=pk) # Вызов Автора <pk>
    book_list_for_author = Book.objects.filter(author = autor_detail.id) #фильтрация Book из БД по имени Author
    # Отрисовка HTML-шаблона index.html с данными внутри переменной контекста context=
    return render(  #отрисовка на экране
        request,
        'ctlg/autor_detail.html',
        context={'athr_dtl': autor_detail,'bk_lst_fr_athr':book_list_for_author}, #создаются имена к спискам с данными для передачи в html
    )



def mybook_view(request):
    """
    Функция отображения для страницы сайта Взятые книги.
    """
    if request.user.is_authenticated != True:   #для зарегистрированного пользователя
            return HttpResponseRedirect('/')    #если польз. не зарегистрирован, то послать его /
            # from django.http import Http404,HttpResponseRedirect вверху этого файла.

    list_my_books = BookInstance.objects.filter(borrower=request.user) # сформировать список list_my_books из 
    # объектов модели BookInstance, но отфильтровав filter(borrower по запрашиваемому пользователю request.user
    page = request.GET.get('page',1)
    paginator = Paginator(list_my_books,1)
    page_list_my_books = paginator.get_page(page)

    return render(  #отрисовать на экране
        request,
        'ctlg/bookinstance_list_borrowed_user.html',        #отрисовать в указанном шаблоне html
        context={'mybks_lst': page_list_my_books}, # Cписок с данными для передачи в html назвать mybks_lst

    )

from django.core.files.storage import FileSystemStorage

def autor_new(request): # метод обработки для соответствующего url маршрут 
    """
    Функция создания новой записи об Авторе и
    обработка внесённых данных на странице ввода.
    """
    if request.method == 'POST':    # проверка метода и, если передача данных, то отправляются в БД
         fs = FileSystemStorage(location='/mediaa/fts-athrs/')
         avtor = Author.objects.create()
         avtor.first_name = request.POST.get('first_name', None)
         avtor.last_name = request.POST.get('last_name', None)
         avtor.date_of_birth = request.POST.get('date_of_birth', None)
         avtor.date_of_death = request.POST.get('date_of_death', None)
       
         avtor.foto = request.FILES['photo'] 
         avtor.save() 
         
    return render(  #отрисовка на экране. Возвращает шаблон
        request,        #по запросу
        'ctlg/autor_form.html'     # указываем словарь, который нужно выводить
       )

                

local_library/catalog/templates/ctlg/autor_detail.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>detail_A</title>
</head>

<body>
    {% extends "base_generic.html" %} {% block content %} {% load static %}
    <h1>Автор: {{ athr_dtl.last_name }}, {{ athr_dtl.first_name }}</h1>
    <hr>
    <p><strong>Жил:</strong> {{athr_dtl.date_of_birth}} - {{athr_dtl.date_of_death}}</p>
    <hr>
    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <div class="card mb-4 box-shadow">
                    <img class="card-img-top" data-src="holder.js/100px225?theme=thumb&amp;bg=55595c&amp;fg=eceeef&amp;text=Thumbnail" alt="Thumbnail [100%x225]" style="height: 100%; width: 100%; display: block;" src="{{ athr_dtl.foto.url }}" data-holder-rendered="true">
                    <div class="card-body">
                        <p class="card-text">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
                        <div class="d-flex justify-content-between align-items-center">
                            <div class="btn-group">
                                <button type="button" class="btn btn-sm btn-outline-secondary">Редактировать информаци об авторе</button>
                            </div>
                            <!-- <small class="text-muted">текст любой</small> -->
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <hr>
    <p><strong>Его произведения:</p>
             
    <!-- список произведений Автора-->
    {% for bl in bk_lst_fr_athr %}
    <li>
        <a href="{{ bl.get_absolute_url }}">{{ bl.title }}</a>
    </li>
    {% endfor %}
    <div class="btn-group">
        <button type="button" class="btn btn-sm btn-outline-secondary">Добавить произведение автора</button>
    </div>
    <hr> {% endblock %}
</body>

</html>

local_library/catalog/templates/ctlg/autor_form.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Форма для добавления Автора</title>
</head>

<body>
    {% extends "base_generic.html" %} {% block content %} {% load static %}
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        <h1>Внесите данные об авторе:</h1>

        <label for="group">44</label>
        <input type="text" class="form-control" name="first_name" id="group" placeholder="1" value="" required="">

        <label for="group">N22</label>
        <input type="text" class="form-control" name="last_name" id="group" placeholder="2" value="" required="">

        <label for="group">Р</label>
        <input type="date" class="form-control" name="date_of_birth" id="group" placeholder="2" value="" required="">

        <label for="group">С</label>
        <input type="date" class="form-control" name="date_of_death" id="group" placeholder="2" value="" required="">

        <label for="group">Фото</label>
        <input type="file" name="photo" accept="image/*" id="id_cover" value="" required="">
        <div class="btn-group">
            <a href="">
                <button type="submit" class="btn btn-sm btn-outline-secondary">Отправить на модерацию</button>
            </a>
    </form>
    {% endblock %}
</body>

</html>

local_library/catalog/templates/ctlg/autors_list.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Список Авторов</title>
</head>

<body>
    {% extends "base_generic.html" %} {% block content %}
    <h1>Список Авторов:</h1>

    {% if p_athrs_lst %}
    <ul>
        {% for aaaa in p_athrs_lst %}
        <li>
            <a href="{{ aaaa.get_absolute_url }}">{{ aaaa.last_name}} {{aaaa.first_name}}</a> ( {{aaaa.date_of_birth}}, - {{aaaa.date_of_death}} )
        </li>
        {% endfor %}
        <hr>
        <div class="btn-group">
            <a href="{% url 'authCrd' %}">
                <button type="button" class="btn btn-sm btn-outline-secondary">Добавить автора</button>
            </a>
        </div>
        <hr>
        <div class="pagination">
            <span class="page-links">
                {% if p_athrs_lst.has_previous %}
                <a href="{{ request.path }}?page={{ p_athrs_lst.previous_page_number }}">Предыдущая</a> {% endif %}
                            <span class="page-current">
                                Page {{ p_athrs_lst.number }} of {{ p_athrs_lst.paginator.num_pages }}.
                            </span> {% if p_athrs_lst.has_next %}
            <a href="{{ request.path }}?page={{ p_athrs_lst.next_page_number }}">Следующая</a> {% endif %}
            </span>
        </div>
    </ul>
    {% else %}
    <p>Здесь пусто, мы никого не знаем</p>
    {% endif %} {% endblock %}
</body>

</html>

local_library/catalog/templates/ctlg/book_detail.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>detail_B</title>
</head>

<body>
    {% extends "base_generic.html" %} {% block content %}
    <!--распростроняем шаблон "base_generic.html" на данную страницу -->
    <h1>Название произведения: {{ bk_dtl.title }}</h1>
    <!--берём Название из подготовленной во view.py временной переменной-->
    <hr>
    <p><strong>Жанр:</strong> {% for genre in bk_dtl.genre.all %} {{ genre }}{% if not forloop.last %}, {% endif %}{% endfor %}</p>
    <p><strong>ISBN:</strong> {{ bk_dtl.isbn }}</p>
    <p><strong>Summary:</strong> {{ bk_dtl.summary }}</p>
    <div class="btn-group">
        <button type="button" class="btn btn-sm btn-outline-secondary">Редактировать</button>
    </div>
    <hr>
    <p><strong>Автор:</strong> <a href="{{ bk_dtl.author.get_absolute_url }}">{{ bk_dtl.author }}</a></p>
    <!-- Ссылка на author_detail возможна только указав bk_dtl в качестве ..., потому что..... -->
    <p><strong>Уроженец:</strong> {{ bk_dtl.language }}</p>



    <hr>
    <div style="margin-left:20px;margin-top:20px">
        <h4>Наличие</h4>

        {% for copy in book.bookinstance_set.all %}

        <p class="{% if copy.status == 'a' %}text-success{% elif copy.status == 'd' %}text-danger{% else %}text-warning{% endif %}">{{ copy.get_status_display }}</p>
        {% if copy.status != 'a' %}
        <p><strong>Появится:</strong> {{copy.due_back}}</p>{% endif %}
        <p><strong>Imprint:</strong> {{copy.imprint}}</p>
        <p class="text-muted"><strong>Id:</strong> {{copy.id}}</p>
        {% endfor %}
    </div>
    {% endblock %}
</body>

</html>

local_library/catalog/templates/ctlg/book_list.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Список произведений</title>
</head>

<body>
    {% extends "base_generic.html" %} {% block content %}
    <h1>Список произведений:</h1>

    {% if p_bk_lst%}
    <ul>
        <!--запрашивает request информацию во view.py из одноимённой переменной-->
        {% for bbbb in p_bk_lst %}
        <li>

            <a href="{{ bbbb.get_absolute_url }}">{{ bbbb.title }}</a> ({{bbbb.author}})
        </li>
        {% endfor %}
        <hr>
        <div class="btn-group">
            <a href="">
                <button type="button" class="btn btn-sm btn-outline-secondary">Добавить произведение</button>
            </a>
        </div>
        <hr>
        <div class="pagination">
            <span class="page-links">
                {% if p_bk_lst.has_previous %}
                <a href="{{ request.path }}?page={{ p_bk_lst.previous_page_number }}">Предыдущая</a> {% endif %}
                            <span class="page-current">
                                Page {{ p_bk_lst.number }} of {{ p_bk_lst.paginator.num_pages }}.
                            </span> {% if p_bk_lst.has_next %}
            <a href="{{ request.path }}?page={{ p_bk_lst.next_page_number }}">Следующая</a> {% endif %}
            </span>
        </div>

    </ul>
    {% else %}
    <p>Здесь пусто. У нас ничего нет.</p>
    {% endif %} {% endblock %}
</body>

</html>

local_library/catalog/templates/ctlg/bookinstance_list_borrowed_user.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>bookInstance list borrowed this user</title>
</head>

<body>
    {% extends "base_generic.html" %} {% block content %}
    <h1>Взятые мною книги:</h1>

    {% if mybks_lst %}
    <ul>

        {% for bkInst in mybks_lst %}
        <li>
            <a href="{{ bkInst.book.get_absolute_url }}">{{bkInst.book.title}}</a> ({{ bkInst.due_back }}) {% endfor %}
            <hr>
            <div class="pagination">
                <span class="page-links">
                    {% if mybks_lst.has_previous %}
                    <a href="{{ request.path }}?page={{ mybks_lst.previous_page_number }}">Предыдущая</a> {% endif %}
                                <span class="page-current">
                                    Page {{ mybks_lst.number }} of {{ mybks_lst.paginator.num_pages }}.
                                </span> {% if mybks_lst.has_next %}
                <a href="{{ request.path }}?page={{ mybks_lst.next_page_number }}">Следующая</a> {% endif %}
                </span>
            </div>
        </li>
    </ul>

    {% else %}
    <p>У Вас нет взятых книг.</p>
    {% endif %} {% endblock %}
</body>

</html>